import { Document, Schema, model } from "mongoose";

export enum FileType {
  CARD_IMAGE,
  PROFILE_PICTURE,
}

export interface IFile extends Document {
  path: string;
  originalName: string;
  encoding: string;
  mimetype: string;
  type: FileType;
}

const FileSchema = new Schema({
  path: { type: String, required: true },
  originalName: { type: String, required: true },
  mimetype: { type: String, required: true },
  type: {
    type: String,
    enum: Object.keys(FileType).map((k) => FileType[k as any]),
    required: true,
  },
});

export default model<IFile>("File", FileSchema);
